/**
  * File: BasicStateHandlerBaseImpl.java
  * Content: Defines an abstract corba class to implement the BasicStateHandler interface
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

/**
  * Implementation of the BasicStateHandler CORBA interface.
  **/
public abstract class BasicStateHandlerBaseImpl extends BasicStateHandlerPOA
{

  public BasicStateHandlerBaseImpl() throws Exception
  {
    this(true);
  }

  public BasicStateHandlerBaseImpl(boolean active) throws Exception
  {
    if (active)
      activate();
  }

  public void activate() throws Exception
  {
    if (thisBasicStateHandler==null)
    {
      id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
      thisBasicStateHandler = BasicStateHandlerHelper.narrow
          (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
    }
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisBasicStateHandler!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      thisBasicStateHandler=null;
    }
  }

  public final BasicStateHandler theBasicStateHandler()
  {
    return thisBasicStateHandler;
  }

  protected BasicStateHandler thisBasicStateHandler;
  byte[] id;
};

