/**
  * File: CoordinatorElectorBaseImpl.java
  * Content: Defines an abstract corba class to implement the CoordinatorElector interface
  * Author: LuisM Pena
  * Date: 25th July 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

/**
  * Implementation of the CoordinatorElector CORBA interface.
  **/
public abstract class CoordinatorElectorBaseImpl extends CoordinatorElectorPOA
{

  public CoordinatorElectorBaseImpl() throws Exception
  {
    this(true);
  }

  public CoordinatorElectorBaseImpl(boolean active) throws Exception
  {
    if (active)
      activate();
  }

  public void activate() throws Exception
  {
    if (thisCoordinatorElector==null)
    {
      id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
      thisCoordinatorElector = CoordinatorElectorHelper.narrow
          (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
    }
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisCoordinatorElector!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      thisCoordinatorElector=null;
    }
  }

  public final CoordinatorElector theCoordinatorElector()
  {
    return thisCoordinatorElector;
  }

  protected CoordinatorElector thisCoordinatorElector;
  byte[] id;
};

