/**
  * File: GroupMonitorBaseImpl.java
  * Content: Monitor implementation on a replicated environment
  * Author: LuisM Pena
  * Date: 03rd October 2000
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

import sensei.middleware.util.ORBcentral;

/**
  * Monitor implementation on a replicated environment
  **/
public abstract class GroupMonitorBaseImpl extends GroupMonitorPOA
{

//*************************************************************************************//
//**************************** CONSTRUCTOR ********************************************//
//*************************************************************************************//

  public GroupMonitorBaseImpl() throws Exception
  {
    this(true);
  }

  public GroupMonitorBaseImpl(boolean active) throws Exception
  {
    if (active)
      activate();
  }

  public void activate() throws Exception
  {
    if (thisGroupMonitor==null)
    {
      id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
      thisGroupMonitor = GroupMonitorHelper.narrow
          (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
    }
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (id!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      id=null;
    }
  }

  public final GroupMonitor theGroupMonitor()
  {
    return thisGroupMonitor;
  }

//*************************************************************************************//
//**************************** DATA MEMBERS *******************************************//
//*************************************************************************************//

  protected GroupMonitor thisGroupMonitor;
  byte[] id;
}
