/**
  * File: GroupMembershipBasicServiceBaseImpl.java
  * Content: Implementation of the GroupMembershipBasicService
  * Author: LuisM Pena
  * Date: 3nd December 2000
  * Version: 0.29.00
  * Last changes:
  *
  **/

package sensei.middleware.gmns;

/**
  * Implementation of the GroupMembershipBasicService
  **/
public abstract class GroupMembershipBasicServiceBaseImpl extends GroupMembershipBasicServicePOA
{
  public GroupMembershipBasicServiceBaseImpl() throws Exception
  {
    id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
    thisGroupMembershipBasicService = GroupMembershipBasicServiceHelper.narrow
        (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisGroupMembershipBasicService!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      thisGroupMembershipBasicService=null;
    }
  }

  public final GroupMembershipBasicService theGroupMembershipBasicService()
  {
    return thisGroupMembershipBasicService;
  }

  protected GroupMembershipBasicService thisGroupMembershipBasicService;
  byte[] id;
};
