/**
  * File: GroupMemberImpl.java
  * Content: Implementation of the GroupMember CORBA interface.
  * Author: LuisM Pena
  * Date: 17th November 2000
  * Version: 0.80.00
  * Last change:
  *
  **/

package sensei.middleware.gms;

/**
  * Class implementing the CORBA interface for the GroupMember.
  **/
public abstract class GroupMemberImpl extends GroupMemberPOA
{
  public GroupMemberImpl() throws Exception
  {
    this(true);
  }

  public GroupMemberImpl(boolean active) throws Exception
  {
    if (active)
      activate();
  }

  public void activate() throws Exception
  {
    if (thisGroupMember==null)
    {
      id = sensei.middleware.util.ORBcentral.getPOA().activate_object(this);
      thisGroupMember = GroupMemberHelper.narrow
          (sensei.middleware.util.ORBcentral.getPOA().id_to_reference(id));
    }
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (id!=null)
        sensei.middleware.util.ORBcentral.getPOA().deactivate_object(id);
      id=null;
    }
  }

  public final GroupMember theGroupMember()
  {
    return thisGroupMember;
  }

  protected GroupMember	thisGroupMember;
  byte[] id;
};

