/**
  * File: StateSenderThreadUser.java
  * Content: Interface to be implemented by users of the StateSenderThread class
  * Author: LuisM Pena
  * Date: 2nd August 2001
  * Version: 0.51.00
  * Last change:
  *
  *
  **/

package sensei.domains;

/**
 * Interface to be implemented by users of the StateSenderThread class
 */
interface StateSenderThreadUser
{
  /**
   * When the message E is sent, if it is requested to be received on the same view, before the blocking
   * is done, this method must return true. In this case, the StateSenderThread checks that the message is
   * sent on the same view and waits for a confirmation on the message reception
   */
  public boolean hasStrongSTMessageConsistency();

  /**
   * Called when there has been an error on the own subgroups. The transfer ends automatically
   */
  public void stateTransferThreadSubgroupError(SubgroupException sex);
}
