/**
  * File: ExitHandlerUser.java
  * Content: Interface to the ExitHandler
  * Author: LuisM Pena
  * Date: 15th December 2001
  * Version: 0.51.00
  * Last change:
  *
  **/

package sensei.domains.utils;

import sensei.middleware.domains.DomainExpulsionReason;

/**
 * Interface to the ExitHandler
 */
public interface ExitHandlerUser
{
  /**
   * After a member requests to leave the group, this event is sent to the user, with
   * the parameter set to true if an exclusion event has been received in time
   */
  public void performExit(boolean memberCorrectlyExcluded);

  /**
   * If a member receives an exclusion event without having requested to leave, the ExitHandler
   * translates it into this event
   */
  public void unsolicitedExclusion(DomainExpulsionReason reason);
}