/**
  * File: Consts.java
  * Content: generic consts in the GMS package
  * Author: LuisM Pena
  * Date: 6th November 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.gms;

import sensei.util.Configuration;

/**
  * Generic consts in the util package.
  **/
final public class Consts
{
  final static public String GMS = "GMS";
  final static public int INVALID_MEMBER_ID = 0;  //ensured to be lower that any valid member id
  final static public int EVERY_MEMBER_ID = 0;    //ensured to be lower that any valid member id

  //configuration values
  static final public int  CHANNEL_DEAD 			= Configuration.getSingleton().getGMSChannelLiveness();
  static final public long TIMEOUT 						= Configuration.getSingleton().getGMSMaxProcessMessageDelay();
  static final public boolean WEAK_CONSENSUS	= Configuration.getSingleton().hasGMSWeakConsensus();
  static final long RETAIN_TOKEN_PERIOD 			= Configuration.getSingleton().getGMSTokenStoppedPeriod();
  static final long RECOVER_TOKEN_PERIOD			= Configuration.getSingleton().getGMSTokenLostTimeout();

  static public int generateValidMemberId(){return ViewHandler.generateFirstMemberId();}

}
