/**
  * File: RecoverTokenChannelRequester.java
  * Content: Defines a channel requester to recover the token
  * Author: LuisM Pena
  * Date: 1st August2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.gms;

import sensei.middleware.gms.SenseiGMSMember;

import sensei.util.Debug;

//*************************************************************************************//
//**************************** RECOVER TOKEN CHANNEL REQUESTER ************************//
//*************************************************************************************//

/**
  * Channel Requester used to sends requests to recover the token
  **/
class RecoverTokenChannelRequester implements ChannelRequester
{
  public RecoverTokenChannelRequester(int thisMember)
  {
    Trace.code("RecoverTokenChannelRequester.java -> RecoverTokenChannelRequester ( int thisMember )");
    this.thisMember = thisMember;
  }

  public boolean invokeMember(CommunicationChannel channel)
  {
    Trace.code("RecoverTokenChannelRequester.java -> boolean invokeMember ( CommunicationChannel channel )");
    Debug.assert(channel!=null, Consts.GMS,"RecoverTokenChannelRequester:invokeMember:1");

    boolean ret;

    SenseiGMSMember channelMember = channel.getLink();

    Debug.assert(channelMember!=null,Consts.GMS,"RecoverTokenChannelRequester:invokeMember:2");

    try
    {
      ret=channelMember.recoverToken(thisMember) && channel.isReliable();
    }
    catch(Exception ex)
    {
      ret=false;
      Trace.handledException(ex);
    }
    return ret;
  }

  int thisMember;
}
