/**
  * File: DomainGroupUserBaseImpl.java
  * Content: Defines an abstract rmi class to implement the DomainGroupUser interface
  * Author: LuisM Pena
  * Date: 28th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/

package sensei.middleware.domains;

import java.rmi.server.UnicastRemoteObject;

/**
  * Defines an abstract rmi class to implement the DomainGroupHandler interface
  **/
public abstract class DomainGroupUserBaseImpl extends UnicastRemoteObject implements DomainGroupUser
{

  public DomainGroupUserBaseImpl() throws Exception
  {
    thisDomainGroupUser=this;
  }

  public DomainGroupUserBaseImpl(boolean activate) throws Exception
  {
    if (!activate)
      deactivate();
  }

  public void activate() throws Exception
  {
    if (thisDomainGroupUser==null)
    {
      thisDomainGroupUser=this;
      exportObject(this);
    }
  }

  public void deactivate() throws Exception
  {
    synchronized (this)
    {
      if (thisDomainGroupUser!=null)
        unexportObject(thisDomainGroupUser,true);
      thisDomainGroupUser=null;
    }
  }

  public final DomainGroupUser theDomainGroupUser()
  {
    return thisDomainGroupUser;
  }

  protected DomainGroupUser thisDomainGroupUser;
};

