/**
  * File: 		MessageP.java
  * Content: 	part of the RMI specification of sensei domains
  *           Message p is the initial message sent between DomainGroupHandlers to
  *           transfer their features, and any state transfer information required
  *           (but not the state itself).
  *           It contains:
  *           (a) generic information about the group itself
  *           (b) information about the subgroup layout
  *           (c) list of current statefull members, with their properties and
  *               members being coordinated
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;
/**
 *  Message p is the initial message sent between DomainGroupHandlers to
 *  transfer their features, and any state transfer information required
 *  (but not the state itself).
 *  It contains:
 *  (a) generic information about the group itself
 *  (b) information about the subgroup layout
 *  (c) list of current statefull members, with their properties and
 *      members being coordinated
 */
public class MessageP extends DomainMessage
{
  public int viewId; //message can only be processed on the right view

  public BehaviourOnViewChanges behaviour;
  public boolean coordinatorElectorRegistered;
  public boolean dynamicSubgroupsAllowed;
  public int nextDynamicSubgroupId;

  public SubgroupProperties[] subgroupsInformation;
  public MemberProperties[] props;
  public ReplicaInformation[] replicasInfo;
}