/**
  * File: 		SubgroupsHandlerException.java
  * Content: 	part of the RMI specification of sensei domains
  *           Exception thrown after a invalid operation on the SubgroupsHandler interface
  * Author: 	LuisM Pena
  * Date:    27th October 2001
  * Version: 0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;

import java.rmi.RemoteException;

final public class SubgroupsHandlerException extends RemoteException
{
    public
    SubgroupsHandlerException()
    {
        super();
    }

    public
    SubgroupsHandlerException(SubgroupsHandlerExceptionReason reason)
    {
        this.reason = reason;
    }

    public
    SubgroupsHandlerException(String _reason,
                              SubgroupsHandlerExceptionReason reason)
    {
        super(_reason);
        this.reason = reason;
    }

    public SubgroupsHandlerExceptionReason reason;
}
