/**
  * File: 		TransactionException.java
  * Content: 	part of the RMI specification of sensei domains
  *           Exception sent during a startTransaction operation when the group handler associated does not
  *           allow transactions (behaviour is not MembersOnTransferExcludedFromGroup)
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;

import java.rmi.RemoteException;

/**
  * Exception sent during a startTransaction operation when the group handler associated does not
  * allow transactions (behaviour is not MembersOnTransferExcludedFromGroup)
 */
final public class TransactionException extends RemoteException
{
    public
    TransactionException()
    {
        super();
    }

    public
    TransactionException(String _reason)
    {
      super(_reason);
    }

}
