/**
  * File: Debug.java
  * Content: Basic debug facilities
  * Author: LuisM Pena
  * Date: 5nd July 2000
  * Version: 0.97.00
  * Last change:
  *
  *
  **/

package sensei.util;

public class Debug
{
  /*debug is set to true if assert conditions must be checked*/
  public static final boolean DEBUG = Configuration.getSingleton().debuggingMode();

  /**
    * Checks if the condition is verified, otherwise the system exits
    **/
  public static void assert(boolean condition, String area, String position)
  {
    if (DEBUG && !condition)
    {
      String error="Assertion: condition not verified ["+area+"@"+position+"]";
      Error.error(area, error);
    }
  }

}
