package senseiTests.concurrency.corba;

import senseiTests.concurrency.TestMonitor;

import sensei.util.Parameters;
import sensei.util.ParameterException;
import org.omg.CORBA.ORB;

import sensei.middleware.util.ORBcentral;

public class Main
{
  public Main(String args[])
  {
    Parameters parameters = TestMonitor.readArgs(args);
    if (parameters!=null)
    {
      ORB orb = null;
      try
      {
        orb = ORB.init(args, System.getProperties());

        ORBcentral.setORB(orb);

        new TestMonitor(new CorbaFactory(),parameters);
        orb.run();
      }
      catch(ParameterException ex)
      {
        System.out.println(ex);
      }
      catch(Exception ex)
      {
        ex.printStackTrace();
      }
      if (orb!=null)
        try {orb.destroy();}catch(Exception ex){}
    }
  }

  public static void main(String args[])
  {
    new Main(args);
  }
}
